export declare const baseElementEvents: string[];
export declare const baseElementProperties: string[];
export declare const anchorProperties: string[];
export declare const buttonProperties: string[];
export declare const divProperties: string[];
/**
 * Gets native supported props for an html element provided the allowance set. Use one of the property
 * sets defined (divProperties, buttonPropertes, etc) to filter out supported properties from a given
 * props set. Note that all data- prefixed attributes will be allowed.
 *
 * @param props The unfiltered input props
 * @param allowedPropsNames The array of allowed propnames.
 * @returns The filtered props
 */
export declare function getNativeProps<T>(props: any, allowedPropNames: string[]): T;
