module.exports = "import * as React from 'react';\nimport { TeachingBubble } from './TeachingBubble';\nimport { TeachingBubbleContent } from './TeachingBubbleContent';\nimport { IImageProps } from '../Image/Image.Props';\nimport { IButtonProps } from '../Button/Button.Props';\nimport { IAccessiblePopupProps } from '../../common/IAccessiblePopupProps';\nimport { ICalloutProps } from '../../index';\n\n/**\n * TeachingBubble component props.\n */\n\nexport interface ITeachingBubbleProps extends React.Props<TeachingBubble|TeachingBubbleContent>, IAccessiblePopupProps {\n  /**\n   * Properties to pass through for Callout, reference detail properties in ICalloutProps\n   */\n  calloutProps?: ICalloutProps;\n\n  /**\n   * A headline for the Teaching Bubble.\n   */\n  headline?: string;\n\n  /**\n   * A variation with smaller bold headline and no margins.\n   */\n  hasCondensedHeadline?: boolean;\n\n  /**\n   * Does the TeachingBubble have a close button in the top right corner?\n   */\n  hasCloseIcon?: boolean;\n\n  /**\n   * An Image for the Teaching Bubble.\n   */\n  illustrationImage?: IImageProps;\n\n  /**\n   * The Primary interaction button\n   */\n  primaryButtonProps?: IButtonProps;\n\n  /**\n   * The Secondary interaction button\n   */\n  secondaryButtonProps?: IButtonProps;\n\n  /**\n   * Element to anchor the TeachingBubble to.\n   */\n  targetElement?: HTMLElement;\n\n  /**\n   * Callback when the TeachingBubble tries to close.\n   */\n  onDismiss?: (ev?: any) => void;\n}";