module.exports = "import * as React from 'react';\nimport { IPickerItemProps } from './PickerItem.Props';\n\n// Type T is the type of the item that is displayed\n// and searched for by the people picker. For example, if the picker is\n// displaying persona's than type T could either be of Persona or Ipersona props\nexport interface IBasePickerProps<T> extends React.Props<any> {\n  /**\n   * Function that specifies how the selected item will appear.\n   */\n  onRenderItem?: (props: IPickerItemProps<T>) => JSX.Element;\n  /**\n   * Function that specifies how an individual suggestion item will appear.\n   */\n  onRenderSuggestionsItem?: (props: T) => JSX.Element;\n  /**\n   * A callback for what should happen when a person types text into the input.\n   * Returns the already selected items so the resolver can filter them out.\n   */\n  onResolveSuggestions: (filter: string, selectedItems?: T[]) => T[];\n  /**\n   * Initial items that have already been selected and should appear in the people picker.\n   */\n  defaultSelectedItems?: T[];\n  /**\n   * A callback for when the selected list of items changes.\n   */\n  onChange?: (items?: T[]) => void;\n  /**\n   * A callback to get text from an item. Used to autofill text in the pickers.\n   */\n  getTextFromItem?: (item: T) => string;\n  /**\n   * A callback that gets the rest of the results when a user clicks get more results.\n   */\n  onGetMoreResults?: (filter: string, selectedItems?: T[]) => T[];\n  /**\n   * ClassName for the picker.\n   */\n  className?: string;\n  /**\n   * The properties that will get passed to the Suggestions component.\n   */\n  pickerSuggestionsProps?: IBasePickerSuggestionsProps;\n}\n\nexport interface IBasePickerSuggestionsProps {\n  /**\n   * The text that should appear at the top of the suggestion box.\n   */\n  suggestionsHeaderText?: string;\n  /**\n   * the text that should appear when no results are returned.\n   */\n  noResultsFoundText?: string;\n  /**\n   * ClassName for the picker.\n   */\n  className?: string;\n  /**\n   * Classname for the suggestion box.\n   */\n  suggestionsClassName?: string;\n  /**\n   * ClassName for suggestion items.\n   */\n  suggestionsItemClassName?: string;\n  /**\n   * The text that should appear on the button to search for more.\n   */\n  searchForMoreText?: string;\n}";